/*
 *  Copyright (c) 1993 Christopher J. Kane.  All rights reserved.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement.  Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version: 1.1 (22 October 1993)
 */

#import <appkit/appkit.h>

@interface MiscFindPanel:Panel
{
  id findTextField;
  id replaceTextField;
  id messageTextField;
  id ignoreCaseButton;
  id regExprButton;
  id scopeMatrix;
  id _replBox;
  id scopeSelection;
  
  id replButton1;
  id replButton2;
  id replButton3;
  
  id replButton4;
}

+ setFindPbEnabled:(BOOL)aBool;
+ setFirstConformer:aConformer;
+ setReplacementEnabled:(BOOL)aBool;
+ sharedInstance;

- enterSelection:sender;
- findBackward:sender;
- findForward:sender;
- jumpToSelection:sender;
- replace:sender;
- replaceAll:sender;
- replaceAndFind:sender;
- grep:sender;
- gscopeChanged:sender;

- (TextField *)findTextField;
- (Button *)ignoreCaseButton;
- (TextField *)messageTextField;
- (Button *)regExprButton;
- (TextField *)replaceTextField;
- (Matrix *)scopeMatrix;
- (Matrix *)scopeSelection;

@end
